//
//  DrawShape.m
//  Jarnaby
//
//  Created by Shin-Young Jung on 10. 11. 18..
//  Copyright 2010 Brigham Young University Hawaii. All rights reserved.
//

#import "DrawShape.h"


@implementation DrawShape
@synthesize l,ls;



-(void)setR:(int)o T:(int)t Th:(int)th F:(int)f{
	one =o;
	two =t;
	three =th;
	four = f;
	l = NO;
	ls = [[NSMutableArray alloc] init];
	
}

-(void)setLink:(int)o T:(int)t Th:(int)th F:(int)f  li:(int)linkinde{
	[ls addObject:[[LinkMap alloc] initwithLs:o tw:t th:th fo:f fiv:linkinde]];
	l =YES;
}

-(void)drawRect:(CGRect)rect {
	
	CGContextRef context = UIGraphicsGetCurrentContext();
	CGContextBeginPath(context);
	CGContextMoveToPoint(context, one, two);
	CGContextAddLineToPoint(context, three, two);
	CGContextAddLineToPoint(context, three, four);
	CGContextAddLineToPoint(context, one, four);
	CGContextAddLineToPoint(context, one, two);
	
	CGContextClosePath(context);
	[[UIColor yellowColor] setFill];
	[[UIColor blackColor]setStroke];
	CGContextDrawPath(context, kCGPathFillStroke);
    //draw point
	CGContextBeginPath(context);
	CGContextMoveToPoint(context, 260, 80+((((two-48)/140)*140)));
	CGContextAddLineToPoint(context, 270,70+((((two-48)/140)*140)));
	CGContextAddLineToPoint(context, 310, 100+((((two-48)/140)*140)));
	CGContextAddLineToPoint(context, 320, 90+((((two-48)/140)*140)));
	CGContextAddLineToPoint(context, 320, 120+((((two-48)/140)*140)));
	CGContextAddLineToPoint(context, 290, 120+((((two-48)/140)*140)));
	CGContextAddLineToPoint(context, 300, 110+((((two-48)/140)*140)));
	CGContextAddLineToPoint(context, 260, 80+((((two-48)/140)*140)));
	
	CGContextClosePath(context);
	[[UIColor yellowColor] setFill];
	[[UIColor blackColor]setStroke];
	CGContextDrawPath(context, kCGPathFillStroke);
	
	if(l){
		for(int i=0; i < [ls count]; i++){

			CGContextRef context = UIGraphicsGetCurrentContext();
			if([[ls objectAtIndex:i] linkindex] % 2 == 0){
				CGContextBeginPath(context);
				//draw line
				CGContextMoveToPoint(context, [[ls objectAtIndex:i] lone], [[ls objectAtIndex:i] ltwo]);
				CGContextAddLineToPoint(context, [[ls objectAtIndex:i] lthree], [[ls objectAtIndex:i] lfour]);
				[[UIColor blackColor]setStroke];
				CGContextClosePath(context);
				CGContextDrawPath(context, kCGPathFillStroke);
				//draw rect
				CGContextBeginPath(context);
				CGContextMoveToPoint(context,[[ls objectAtIndex:i] lthree]-55 , [[ls objectAtIndex:i] lfour]);
				CGContextAddLineToPoint(context, [[ls objectAtIndex:i] lthree]+55, [[ls objectAtIndex:i] lfour]);
				CGContextAddLineToPoint(context, [[ls objectAtIndex:i] lthree]+55, [[ls objectAtIndex:i] lfour]+120);
				CGContextAddLineToPoint(context, [[ls objectAtIndex:i] lthree]-55, [[ls objectAtIndex:i] lfour]+120);
				CGContextAddLineToPoint(context, [[ls objectAtIndex:i] lthree]-55, [[ls objectAtIndex:i] lfour]);
				
				CGContextClosePath(context);
				[[UIColor blackColor] setFill];
				[[UIColor blackColor]setStroke];
				CGContextDrawPath(context, kCGPathFillStroke);
			} else {
				CGContextBeginPath(context);
				//draw line
				CGContextMoveToPoint(context, [[ls objectAtIndex:i] lone]+110, [[ls objectAtIndex:i] ltwo]);
				CGContextAddLineToPoint(context, [[ls objectAtIndex:i] lthree]+[[ls objectAtIndex:i] lone]+110, [[ls objectAtIndex:i] lfour]);
				[[UIColor blackColor]setStroke];
				CGContextClosePath(context);
				CGContextDrawPath(context, kCGPathFillStroke);
				//draw rect
				CGContextBeginPath(context);
				CGContextMoveToPoint(context,[[ls objectAtIndex:i] lthree]+[[ls objectAtIndex:i] lone]+110-55 , [[ls objectAtIndex:i] lfour]);
				CGContextAddLineToPoint(context, [[ls objectAtIndex:i] lthree]+[[ls objectAtIndex:i] lone]+110+55, [[ls objectAtIndex:i] lfour]);
				CGContextAddLineToPoint(context, [[ls objectAtIndex:i] lthree]+[[ls objectAtIndex:i] lone]+110+55, [[ls objectAtIndex:i] lfour]+120);
				CGContextAddLineToPoint(context, [[ls objectAtIndex:i] lthree]+[[ls objectAtIndex:i] lone]+110-55, [[ls objectAtIndex:i] lfour]+120);
				CGContextAddLineToPoint(context, [[ls objectAtIndex:i] lthree]+[[ls objectAtIndex:i] lone]+110-55, [[ls objectAtIndex:i] lfour]);
				
				CGContextClosePath(context);
				[[UIColor blackColor] setFill];
				[[UIColor blackColor]setStroke];
				CGContextDrawPath(context, kCGPathFillStroke);
				
			}
		}
	}
}
@end
