//
//  Story.m
//  Jarnaby
//
//  Created by Shin-Young Jung on 10. 9. 27..
//  Copyright 2010 Brigham Young University Hawaii. All rights reserved.
//

#import "Story.h"


@implementation Story

@synthesize title,paths, links_id, Links,currentPage, currentPath, currentPageID,index,rect,maaap, currentPathnum;


-(id)init {
	parser = [[Parser alloc] init];
	maaap = [[NSMutableArray alloc] initWithArray:parser.maap];
	title =parser.title;
	index =0;
	currentPage = [[Page alloc] init];
	currentPath = [[Path alloc] init];
    currentPathnum =0;
	//init paths and put into the array
	paths = [[NSMutableArray alloc] initWithArray:[parser paths]];
	
	rect = [[NSMutableDictionary alloc] initWithDictionary:parser.rects];
	//NSLog(@"%f", [[rect objectForKey:[NSString stringWithFormat:@"%d", 3]] xPos]);
	
	//loading pages to put into paths through ID
	for(int i=0; i < [paths count]; i++){
		for(int j=0; j <[[[paths objectAtIndex:i] pathnum] count]; j++){
			for(int k=0; k < [[parser pages] count]; k++){
				if([[[[paths objectAtIndex:i] pathnum] objectAtIndex:j] integerValue] == [[[parser pages] objectAtIndex:k] ID]){
					[[[paths objectAtIndex:i] pages] addObject:[[parser pages] objectAtIndex:k]];
				}
			}
		}
	}

	//loading links from parser
	Links = [[NSMutableDictionary alloc] initWithDictionary:parser.Links];
	return self;
}


-(Page *)getPage:(int)n {
	Page *p;
	int c = [[self.currentPath pages] count];
	for(int i=0; i < c; i++) {
		int ex = [[[self.currentPath pages] objectAtIndex:i] ID];
		if(n == ex){
			p = [[self.currentPath pages] objectAtIndex:i];
		}
	}
	return p;	
}

@end
